/*
 * @(#) ClassFileHandler.java	1.1 99/12/20
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.compiler;

/**
 * This interface defines an abstract interface to get a
 * result of compilation.  This interface is used by the following methods.
 * <ul>
 * <li>Compiler.compile(Pnuts, ClassFileHandler)
 * <li>Compiler.compile(String, ClassFileHandler)
 * <li>Compiler.compile(PnutsFunction, ClassFileHandler)
 * </ul>
 */
public interface ClassFileHandler {

    /**
     * This method is called with each compiled class file when
     * Compiler.compile(Pnuts, ClassFileHandler) method is called.
     * The first class file is supposed to be of pnuts.lang.Runtime
     * subclass.  The compiled code can be executed with
     * Runtime.execute(Context) method.
     */
    public void handle(CompileContext cc, ClassFile cf);

    /**
     * This method is called when all class files are handled.
     * The returned object will be the result of the method call,
     * Compiler.compile(Pnuts, ClassFileHandler).
     */
    public Object getResult(CompileContext cc);
}
