/*
 * @(#) CodeLoader0.java	1.3 00/08/01
 *
 * Copyright (c) 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.compiler;

import pnuts.lang.Pnuts;

/**
 * This class is used with JDK1.1, to define classes from bytecode.
 */
final class CodeLoader0 extends CodeLoader {

    private ClassLoader parent;

    CodeLoader0(){
    }

    CodeLoader0(ClassLoader loader){
	this.parent = loader;
    }

    void init(){ }

    protected Class loadClass(String name, boolean resolve) throws ClassNotFoundException {
	Class c = findLoadedClass(name);
	if (c == null) {
	    try {
		c = findSystemClass(name);
	    } catch (ClassNotFoundException e) {
		if (parent != null){
		    c = parent.loadClass(name);
		} else {
		    throw e;
		}
	    }
	}
	if (resolve) {
	    resolve(c);
	}
	return c;
    }

    Class define(String name, byte data[], int offset, int length){
	return defineClass(name, data, offset, length);
    }
}
