/*
 * @(#) Label.java	1.2 00/02/08
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.compiler;

public class Label {
    ClassFile cf;
    int target_pc = -1;
    IntArray pc = new IntArray();
    int size;

    Label(ClassFile cf){
	this.cf = cf;
    }

    public void fix(){
	target_pc = cf.codeBuffer.size();
	setPosition(target_pc);
    }

    void setOffset(int offset){
	setPosition(target_pc + offset);
    }

    void setPosition(int tgt){
	int array[] = pc.getArray();
	int sz = pc.size();
	for (int i = 0; i < sz; i++){
	    if (size == 2){
		cf.codeBuffer.set((short)(tgt - array[i]), array[i] + 1);
	    } else if (size == 4){
		cf.codeBuffer.set((int)(tgt - array[i]), array[i] + 1);
	    }
	}
    }

    short getPosition(){
	return (short)target_pc;
    }

    void register(int pos, int size){
	pc.add(pos);
	this.size = size;
	if (target_pc > 0){
	    setPosition(target_pc);
	} else {
	    if (size == 2){
		cf.codeBuffer.add((short)0);
	    } else if (size == 4){
		cf.codeBuffer.add((int)0);
	    }
	}
    }
}
