/*
 * @(#) Opcode.java	1.1 99/10/25
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.compiler;

public interface Opcode {

    byte NOP = 0x00;
    byte ACONST_NULL = 0x01;
    byte ICONST_M1 = 0x02;
    byte ICONST_0 = 0x03;
    byte ICONST_1 = 0x04;
    byte ICONST_2 = 0x05;
    byte ICONST_3 = 0x06;
    byte ICONST_4 = 0x07;
    byte ICONST_5 = 0x08;
    byte LCONST_0 = 0x09;
    byte LCONST_1 = 0x0A;
    byte FCONST_0 = 0x0B;
    byte FCONST_1 = 0x0C;
    byte FCONST_2 = 0x0D;
    byte DCONST_0 = 0x0E;
    byte DCONST_1 = 0x0F;
    byte BIPUSH = 0x10;
    byte SIPUSH = 0x11;
    byte LDC = 0x12;
    byte LDC_W = 0x13;
    byte LDC2_W = 0x14;
    byte ILOAD = 0x15;
    byte LLOAD = 0x16;
    byte FLOAD = 0x17;
    byte DLOAD = 0x18;
    byte ALOAD = 0x19;
    byte ILOAD_0 = 0x1A;
    byte ILOAD_1 = 0x1B;
    byte ILOAD_2 = 0x1C;
    byte ILOAD_3 = 0x1D;
    byte LLOAD_0 = 0x1E;
    byte LLOAD_1 = 0x1F;
    byte LLOAD_2 = 0x20;
    byte LLOAD_3 = 0x21;
    byte FLOAD_0 = 0x22;
    byte FLOAD_1 = 0x23;
    byte FLOAD_2 = 0x24;
    byte FLOAD_3 = 0x25;
    byte DLOAD_0 = 0x26;
    byte DLOAD_1 = 0x27;
    byte DLOAD_2 = 0x28;
    byte DLOAD_3 = 0x29;
    byte ALOAD_0 = 0x2A;
    byte ALOAD_1 = 0x2B;
    byte ALOAD_2 = 0x2C;
    byte ALOAD_3 = 0x2D;
    byte IALOAD = 0x2E;
    byte LALOAD = 0x2F;
    byte FALOAD = 0x30;
    byte DALOAD = 0x31;
    byte AALOAD = 0x32;
    byte BALOAD = 0x33;
    byte CALOAD = 0x34;
    byte SALOAD = 0x35;
    byte ISTORE = 0x36;
    byte LSTORE = 0x37;
    byte FSTORE = 0x38;
    byte DSTORE = 0x39;
    byte ASTORE = 0x3A;
    byte ISTORE_0 = 0x3B;
    byte ISTORE_1 = 0x3C;
    byte ISTORE_2 = 0x3D;
    byte ISTORE_3 = 0x3E;
    byte LSTORE_0 = 0x3F;
    byte LSTORE_1 = 0x40;
    byte LSTORE_2 = 0x41;
    byte LSTORE_3 = 0x42;
    byte FSTORE_0 = 0x43;
    byte FSTORE_1 = 0x44;
    byte FSTORE_2 = 0x45;
    byte FSTORE_3 = 0x46;
    byte DSTORE_0 = 0x47;
    byte DSTORE_1 = 0x48;
    byte DSTORE_2 = 0x49;
    byte DSTORE_3 = 0x4A;
    byte ASTORE_0 = 0x4B;
    byte ASTORE_1 = 0x4C;
    byte ASTORE_2 = 0x4D;
    byte ASTORE_3 = 0x4E;
    byte IASTORE = 0x4F;
    byte LASTORE = 0x50;
    byte FASTORE = 0x51;
    byte DASTORE = 0x52;
    byte AASTORE = 0x53;
    byte BASTORE = 0x54;
    byte CASTORE = 0x55;
    byte SASTORE = 0x56;
    byte POP = 0x57;
    byte POP2 = 0x58;
    byte DUP = 0x59;
    byte DUP_X1 = 0x5A;
    byte DUP_X2 = 0x5B;
    byte DUP2 = 0x5C;
    byte DUP2_X1 = 0x5D;
    byte DUP2_X2 = 0x5E;
    byte SWAP = 0x5F;
    byte IADD = 0x60;
    byte LADD = 0x61;
    byte FADD = 0x62;
    byte DADD = 0x63;
    byte ISUB = 0x64;
    byte LSUB = 0x65;
    byte FSUB = 0x66;
    byte DSUB = 0x67;
    byte IMUL = 0x68;
    byte LMUL = 0x69;
    byte FMUL = 0x6A;
    byte DMUL = 0x6B;
    byte IDIV = 0x6C;
    byte LDIV = 0x6D;
    byte FDIV = 0x6E;
    byte DDIV = 0x6F;
    byte IREM = 0x70;
    byte LREM = 0x71;
    byte FREM = 0x72;
    byte DREM = 0x73;
    byte INEG = 0x74;
    byte LNEG = 0x75;
    byte FNEG = 0x76;
    byte DNEG = 0x77;
    byte ISHL = 0x78;
    byte LSHL = 0x79;
    byte ISHR = 0x7A;
    byte LSHR = 0x7B;
    byte IUSHR = 0x7C;
    byte LUSHR = 0x7D;
    byte IAND = 0x7E;
    byte LAND = 0x7F;
    byte IOR = (byte)0x80;
    byte LOR = (byte)0x81;
    byte IXOR = (byte)0x82;
    byte LXOR = (byte)0x83;
    byte IINC = (byte)0x84;
    byte I2L = (byte)0x85;
    byte I2F = (byte)0x86;
    byte I2D = (byte)0x87;
    byte L2I = (byte)0x88;
    byte L2F = (byte)0x89;
    byte L2D = (byte)0x8A;
    byte F2I = (byte)0x8B;
    byte F2L = (byte)0x8C;
    byte F2D = (byte)0x8D;
    byte D2I = (byte)0x8E;
    byte D2L = (byte)0x8F;
    byte D2F = (byte)0x90;
    byte I2B = (byte)0x91;
    byte I2C = (byte)0x92;
    byte I2S = (byte)0x93;
    byte LCMP = (byte)0x94;
    byte FCMPL = (byte)0x95;
    byte FCMPG = (byte)0x96;
    byte DCMPL = (byte)0x97;
    byte DCMPG = (byte)0x98;
    byte IFEQ = (byte)0x99;
    byte IFNE = (byte)0x9A;
    byte IFLT = (byte)0x9B;
    byte IFGE = (byte)0x9C;
    byte IFGT = (byte)0x9D;
    byte IFLE = (byte)0x9E;
    byte IF_ICMPEQ = (byte)0x9F;
    byte IF_ICMPNE = (byte)0xA0;
    byte IF_ICMPLT = (byte)0xA1;
    byte IF_ICMPGE = (byte)0xA2;
    byte IF_ICMPGT = (byte)0xA3;
    byte IF_ICMPLE = (byte)0xA4;
    byte IF_ACMPEQ = (byte)0xA5;
    byte IF_ACMPNE = (byte)0xA6;
    byte GOTO = (byte)0xA7;
    byte JSR = (byte)0xA8;
    byte RET = (byte)0xA9;
    byte TABLESWITCH = (byte)0xAA;
    byte LOOKUPSWITCH = (byte)0xAB;
    byte IRETURN = (byte)0xAC;
    byte LRETURN = (byte)0xAD;
    byte FRETURN = (byte)0xAE;
    byte DRETURN = (byte)0xAF;
    byte ARETURN = (byte)0xB0;
    byte RETURN = (byte)0xB1;
    byte GETSTATIC = (byte)0xB2;
    byte PUTSTATIC = (byte)0xB3;
    byte GETFIELD = (byte)0xB4;
    byte PUTFIELD = (byte)0xB5;
    byte INVOKEVIRTUAL = (byte)0xB6;
    byte INVOKESPECIAL = (byte)0xB7;
    byte INVOKESTATIC = (byte)0xB8;
    byte INVOKEINTERFACE = (byte)0xB9;

    byte NEW = (byte)0xBB;
    byte NEWARRAY = (byte)0xBC;
    byte ANEWARRAY = (byte)0xBD;
    byte ARRAYLENGTH = (byte)0xBE;
    byte ATHROW = (byte)0xBF;
    byte CHECKCAST = (byte)0xC0;
    byte INSTANCEOF = (byte)0xC1;
    byte MONITORENTER = (byte)0xC2;
    byte MONITOREXIT = (byte)0xC3;
    byte WIDE = (byte)0xC4;
    byte MULTIANEWARRAY = (byte)0xC5;
    byte IFNULL = (byte)0xC6;
    byte IFNONNULL = (byte)0xC7;
    byte GOTO_W = (byte)0xC8;
    byte JSR_W = (byte)0xC9;
    byte BREAKPOINT = (byte)0xCA;
    byte LDC_QUICK = (byte)0xCB;
    byte LDC_W_QUICK = (byte)0xCC;
    byte LDC2_W_QUICK = (byte)0xCD;
    byte GETFIELD_QUICK = (byte)0xCE;
    byte PUTFIELD_QUICK = (byte)0xCF;
    byte GETFIELD2_QUICK = (byte)0xD0;
    byte PUTFIELD2_QUICK = (byte)0xD1;
    byte GETSTATIC_QUICK = (byte)0xD2;
    byte PUTSTATIC_QUICK = (byte)0xD3;
    byte GETSTATIC2_QUICK = (byte)0xD4;
    byte PUTSTATIC2_QUICK = (byte)0xD5;
    byte INVOKEVIRTUAL_QUICK = (byte)0xD6;
    byte INVOKENONVIRTUAL_QUICK = (byte)0xD7;
    byte INVOKESUPER_QUICK = (byte)0xD8;
    byte INVOKESTATIC_QUICK = (byte)0xD9;
    byte INVOKEINTERFACE_QUICK = (byte)0xDA;
    byte INVOKEVIRTUALOBJECT_QUICK = (byte)0xDB;

    byte NEW_QUICK = (byte)0xDD;
    byte ANEWARRAY_QUICK = (byte)0xDE;
    byte MULTIANEWARRAY_QUICK = (byte)0xDF;
    byte CHECKCAST_QUICK = (byte)0xE0;
    byte INSTANCEOF_QUICK = (byte)0xE1;
    byte INVOKEVIRTUAL_QUICK_W = (byte)0xE2;
    byte GETFIELD_QUICK_W = (byte)0xE3;
    byte PUTFIELD_QUICK_W = (byte)0xE4;
    byte IMPDEP1 = (byte)0xFE;
    byte IMPDEP2 = (byte)0xFF;
    
    /** 
     * Types for the NEWARRAY opcode.
     */
    byte T_BOOLEAN = 4;
    byte T_CHAR = 5;
    byte T_FLOAT = 6;
    byte T_DOUBLE = 7;
    byte T_BYTE = 8;
    byte T_SHORT = 9;
    byte T_INT = 10;
    byte T_LONG = 11;

    /**
     *  The effect on the operand stack of a given opcode.
     */
    static final byte[] stackGrowth = {
        0, 	// nop
        1,	// aconst_null
        1,	// iconst_m1
        1,	// iconst_0
        1,	// iconst_1
        1,	// iconst_2
        1,	// iconst_3
        1,	// iconst_4
        1,	// iconst_5
        2,	// lconst_0
        2,	// lconst_1
        1,	// fconst_0
        1,	// fconst_1
        1,	// fconst_2
        2,	// dconst_0
        2,	// dconst_1
        1,	// bipush
        1,	// sipush
        1,	// ldc
        1,	// ldc_W
        2,	// ldc2_W
        1,	// iload
        2,	// lload
        1,	// fload
        2,	// dload
        1,	// aload
        1,	// iload_0
        1,	// iload_1
        1,	// iload_2
        1,	// iload_3
        2,	// lload_0
        2,	// lload_1
        2,	// lload_2
        2,	// lload_3
        1,	// fload_0
        1,	// fload_1
        1,	// fload_2
        1,	// fload_3
        2,	// dload_0
        2,	// dload_1
        2,	// dload_2
        2,	// dload_3
        1,	// aload_0
        1,	// aload_1
        1,	// aload_2
        1,	// aload_3
        -1,	// iaload
        0,	// laload
        -1,	// faload
        0,	// daload
        -1,	// aaload
        -1,	// baload
        -1,	// caload
        -1,	// saload
        -1,	// istore
        -2,	// lstore
        -1,	// fstore
        -2,	// dstore
        -1,	// astore
        -1,	// istore_0
        -1,	// istore_1
        -1,	// istore_2
        -1,	// istore_3
        -2,	// lstore_0
        -2,	// lstore_1
        -2,	// lstore_2
        -2,	// lstore_3
        -1,	// fstore_0
        -1,	// fstore_1
        -1,	// fstore_2
        -1,	// fstore_3
        -2,	// dstore_0
        -2,	// dstore_1
        -2,	// dstore_2
        -2,	// dstore_3
        -1,	// astore_0
        -1,	// astore_1
        -1,	// astore_2
        -1,	// astore_3
        -3,	// iastore
        -4,	// lastore
        -3,	// fastore
        -4,	// dastore
        -3,	// aastore
        -3,	// bastore
        -3,	// castore
        -3,	// sastore
        -1,	// pop
        -2,	// pop2
        1,	// dup
        1,	// dup_X1
        1,	// dup_X2
        2,	// dup2
        2,	// dup2_X1
        2,	// dup2_X2
        0,	// swap
        -1,	// iadd
        -2,	// ladd
        -1,	// fadd
        -2,	// dadd
        -1,	// isub
        -2,	// lsub
        -1,	// fsub
        -2,	// dsub
        -1,	// imul
        -2,	// lmul
        -1,	// fmul
        -2,	// dmul
        -1,	// idiv
        -2,	// ldiv
        -1,	// fdiv
        -2,	// ddiv
        -1,	// irem
        -2,	// lrem
        -1,	// frem
        -2,	// drem
        0,	// ineg
        0,	// lneg
        0,	// fneg
        0,	// dneg
        -1,	// ishl
        -1,	// lshl
        -1,	// ishr
        -1,	// lshr
        -1,	// iushr
        -1,	// lushr
        -1,	// iand
        -2,	// land
        -1,	// ior
        -2,	// lor
        -1,	// ixor
        -2,	// lxor
        0,	// iinc
        1,	// i2l
        0,	// i2f
        1,	// i2d
        -1,	// l2i
        -1,	// l2f
        0,	// l2d
        0,	// f2i
        1,	// f2l
        1,	// f2d
        -1,	// d2i
        0,	// d2l
        -1,	// d2f
        0,	// i2b
        0,	// i2c
        0,	// i2s
        -3,	// lcmp
        -1,	// fcmpl
        -1,	// fcmpg
        -3,	// dcmpl
        -3,	// dcmpg
        -1,	// ifeq
        -1,	// ifne
        -1,	// iflt
        -1,	// ifge
        -1,	// ifgt
        -1,	// ifle
        -2,	// if_icmpeq
        -2,	// if_icmpne
        -2,	// if_icmplt
        -2,	// if_icmpge
        -2,	// if_icmpgt
        -2,	// if_icmple
        -2,	// if_acmpeq
        -2,	// if_acmpne
        0,	// goto
        1,	// jsr
        0,	// ret
        -1,	// tableswitch
        -1,	// lookupswitch
        -1,	// ireturn
        -2,	// lreturn
        -1,	// freturn
        -2,	// dreturn
        -1,	// areturn
        0,	// return
        1,	// getstatic
        0,	// putstatic
        -1,	// getfield
        -1,	// putfield
        -1,	// invokevirtual
        -1,	// invokespecial
        0,	// invokestatic
        -1,	// invokeinterface
        0,	// UNUSED
        1,	// new
        0,	// newarray
        0,	// anewarray
        0,	// arraylength
        -1,	// athrow
        0,	// checkcast
        0,	// instanceof
        -1,	// monitorenter
        -1,	// monitorexit
        0,	// wide
        1,	// multianewarray
        -1,	// ifnull
        -1,	// ifnonnull
        0,	// goto_w
        1,	// jsr_w
        0,	// breakpoint
        1,	// ldc_quick
        1,	// ldc_w_quick
        2,	// ldc2_w_quick
        0,	// getfield_quick
        0,	// putfield_quick
        0,	// getfield2_quick
        0,	// putfield2_quick
        0,	// getstatic_quick
        0,	// putstatic_quick
        0,	// getstatic2_quick
        0,	// putstatic2_quick
        0,	// invokevirtual_quick
        0,	// invokenonvirtual_quick
        0,	// invokesuper_quick
        0,	// invokestatic_quick
        0,	// invokeinterface_quick
        0,	// invokevirtualobject_quick
        0,	// UNUSED
        1,	// new_quick
        1,	// anewarray_quick
        1,	// multianewarray_quick
        -1,	// checkcast_quick
        0,	// instanceof_quick
        0,	// invokevirtual_quick_w
        0,	// getfield_quick_w
        0	// putfield_quick_w
    };
}
