/*
 * @(#) RefCache.java	1.2 00/07/06
 *
 * Copyright (c) 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ext;

import java.util.HashMap;
import java.lang.ref.SoftReference;
import pnuts.lang.Cache;

public final class RefCache extends Cache {
    private HashMap map = new HashMap();

    public RefCache(){
    }

    public Object get(Object key){
	SoftReference ref = (SoftReference)map.get(key);
	if (ref == null){
	    return null;
	} else {
	    return ref.get();
	}
    }

    public void put(Object key, Object value){
	map.put(key, new SoftReference(value));
    }
}
