/*
 * @(#) Stack.java	1.4 99/11/01
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

/**
 * Stack implemented by a linked list
 *
 * @author	Toyokazu Tomatsu
 * @version	1.4
 */
class Stack {

    static class Cell {
	Cell next;
	Object object;
    }

    Cell cell;
    int count = 0;

    public void push(Object object){
	Cell old = cell;
	cell = new Cell();
	cell.object = object;
	cell.next = old;
	count++;
    }

    public Object pop(){
	Cell c = cell;
	cell = cell.next;
	count--;
	return c.object;
    }

    public int size(){
	return count;
    }

    public Object peek(){
	return cell.object;
    }

    public void removeAllElements(){
	cell = null;
	count = 0;
    }
}
