/*
 * @(#) ThreadAdapter.java	1.3 00/08/08
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.util;

import pnuts.lang.PnutsFunction;
import pnuts.lang.Context;

/**
 * An adapter class between PnutsFunction and Runnable
 *
 * @version	1.3
 */
public class ThreadAdapter implements Runnable {
    PnutsFunction func;
    Context context;
    
    public ThreadAdapter(PnutsFunction func){
	this(func, new Context());
    }

    public ThreadAdapter(PnutsFunction func, Context context){
	this.func = func;
	this.context = context;
    }

    public void run(){
	func.call(new Object[]{}, (Context)context.clone(false));
    }
}
